drm/rockchip: Don't change hdmi reference clock rate
[drm/drm-misc.git] / tools / perf / tests / shell / test_arm_spe.sh
blob3258368634f793a1c5cde4c065f30f4404b0dcec
1 #!/bin/sh
2 # Check Arm SPE trace data recording and synthesized samples (exclusive)
4 # Uses the 'perf record' to record trace data of Arm SPE events;
5 # then verify if any SPE event samples are generated by SPE with
6 # 'perf script' and 'perf report' commands.
8 # SPDX-License-Identifier: GPL-2.0
9 # German Gomez <german.gomez@arm.com>, 2021
11 skip_if_no_arm_spe_event() {
12 perf list pmu | grep -E -q 'arm_spe_[0-9]+//' && return 0
14 # arm_spe event doesn't exist
15 return 2
18 skip_if_no_arm_spe_event || exit 2
20 perfdata=$(mktemp /tmp/__perf_test.perf.data.XXXXX)
21 glb_err=0
23 cleanup_files()
25 rm -f ${perfdata}
26 rm -f ${perfdata}.old
27 exit $glb_err
30 trap cleanup_files EXIT TERM INT
32 arm_spe_report() {
33 if [ $2 = 0 ]; then
34 echo "$1: PASS"
35 elif [ $2 = 2 ]; then
36 echo "$1: SKIPPED"
37 else
38 echo "$1: FAIL"
39 glb_err=$2
43 perf_script_samples() {
44 echo "Looking at perf.data file for dumping samples:"
46 # from arm-spe.c/arm_spe_synth_events()
47 events="(ld1-miss|ld1-access|llc-miss|lld-access|tlb-miss|tlb-access|branch-miss|remote-access|memory)"
49 # Below is an example of the samples dumping:
50 # dd 3048 [002] 1 l1d-access: ffffaa64999c __GI___libc_write+0x3c (/lib/aarch64-linux-gnu/libc-2.27.so)
51 # dd 3048 [002] 1 tlb-access: ffffaa64999c __GI___libc_write+0x3c (/lib/aarch64-linux-gnu/libc-2.27.so)
52 # dd 3048 [002] 1 memory: ffffaa64999c __GI___libc_write+0x3c (/lib/aarch64-linux-gnu/libc-2.27.so)
53 perf script -F,-time -i ${perfdata} 2>&1 | \
54 grep -E " +$1 +[0-9]+ .* +${events}:(.*:)? +" > /dev/null 2>&1
57 perf_report_samples() {
58 echo "Looking at perf.data file for reporting samples:"
60 # Below is an example of the samples reporting:
61 # 73.04% 73.04% dd libc-2.27.so [.] _dl_addr
62 # 7.71% 7.71% dd libc-2.27.so [.] getenv
63 # 2.59% 2.59% dd ld-2.27.so [.] strcmp
64 perf report --stdio -i ${perfdata} 2>&1 | \
65 grep -E " +[0-9]+\.[0-9]+% +[0-9]+\.[0-9]+% +$1 " > /dev/null 2>&1
68 arm_spe_snapshot_test() {
69 echo "Recording trace with snapshot mode $perfdata"
70 perf record -o ${perfdata} -e arm_spe// -S \
71 -- dd if=/dev/zero of=/dev/null > /dev/null 2>&1 &
72 PERFPID=$!
74 # Wait for perf program
75 sleep 1
77 # Send signal to snapshot trace data
78 kill -USR2 $PERFPID
80 # Stop perf program
81 kill $PERFPID
82 wait $PERFPID
84 perf_script_samples dd &&
85 perf_report_samples dd
87 err=$?
88 arm_spe_report "SPE snapshot testing" $err
91 arm_spe_system_wide_test() {
92 echo "Recording trace with system-wide mode $perfdata"
94 perf record -o - -e dummy -a -B true > /dev/null 2>&1
95 if [ $? != 0 ]; then
96 arm_spe_report "SPE system-wide testing" 2
97 return
100 perf record -o ${perfdata} -e arm_spe// -a --no-bpf-event \
101 -- dd if=/dev/zero of=/dev/null count=100000 > /dev/null 2>&1
103 perf_script_samples dd &&
104 perf_report_samples dd
106 err=$?
107 arm_spe_report "SPE system-wide testing" $err
110 arm_spe_snapshot_test
111 arm_spe_system_wide_test
113 exit $glb_err